<?xml version='1.0' encoding='UTF-8' ?>
<!DOCTYPE composition PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<ui:composition xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
                xmlns="http://www.w3.org/1999/xhtml"
                xmlns:pt="http://xmlns.jcp.org/jsf/passthrough"
                template="./../plantilla-principal.xhtml"
                xmlns:h="http://xmlns.jcp.org/jsf/html"
                xmlns:jsf="http://xmlns.jcp.org/jsf"
                xmlns:f="http://xmlns.jcp.org/jsf/core">

    <ui:define name="contenido">
        <!--En construcción...-->
        <h2 class="ui header">Terminales de impresión</h2>
        <h:form id="form-barra" class="ui secondary menu">

            <div class="ui fitted item">
                <h:commandLink id="btn-limpiar" class="ui right labeled green icon button" actionListener="#{terminalesImpresionManBean.limpiar()}">
                    <i class="file icon" />
                    Limpiar
                    <f:ajax execute="@this" render="form-datos" />
                </h:commandLink>
            </div>
            <div class="ui fitted item">
                <div id="btn-elim" class="ui right labeled red icon button" style="display: none">
                    <i class="trash icon" />
                    Eliminar
                </div>
            </div>

        </h:form>
        <div class="ui grid">
            <div class="ten wide column">
                <div class="ui fluid icon input">
                    <i class="search icon" />
                    <input type="text" placeholder="Buscar..." />
                </div>
                <h:form id="form-tabla">
                    <h:inputHidden id="idterminal" value="#{terminalesImpresionManBean.tmpIdTerminal}" />
                    <h:inputHidden id="fechahoraasignacion" value="#{terminalesImpresionManBean.tmpFechaHoraAsignacion}"/>
                    <table jsf:id="tabla-datos" class="ui selectable celled table">
                        <thead>
                            <tr>
                                <th class="collapsing">
                                    <div onclick="seleccionarTodo()" class="ui fitted checkbox">
                                        <input type="checkbox" id="chk-selec-todo"/>
                                        <label/>
                                    </div>
                                </th>
                                <th class="collapsing">ID</th>
                                <th>Descripción</th>
                                <th class="collapsing">Fecha asignación</th>
                                <th class="collapsing">Este equipo</th>
                                <th class="collapsing">
                                    a
                                </th>
                            </tr>
                        </thead>
                        <tbody>
                            <ui:repeat value="#{terminalesImpresionManBean.lstTerminales}" var="terminal" varStatus="terminalStatus">
                                <tr id="rw-#{terminal.idterminalImpresion}">
                                    <td>
                                        <div onclick="selecFila(#{terminal.idterminalImpresion})" class="ui fitted checkbox">
                                            <input type="checkbox" id="chk-sl-#{terminal.idterminalImpresion}"/>
                                            <label/>
                                        </div>
                                    </td>
                                    <td id="col-id-term" onclick="selecUnica(#{terminal.idterminalImpresion})">#{terminal.idterminalImpresion}</td>
                                    <td onclick="selecUnica(#{terminal.idterminalImpresion})">#{terminal.descripcion}</td>
                                    <td onclick="selecUnica(#{terminal.idterminalImpresion})">
                                        <h:outputText value="#{terminal.fechaAsignacion}">
                                            <f:convertDateTime pattern="dd/MMMM/yyyy HH:mm:ss" />
                                        </h:outputText>
                                    </td>
                                    <td><i id="ico-este-eq-#{terminal.idterminalImpresion}" class="minus icon" /></td>
                                    <td>
                                        <h:commandLink class="ui right labeled icon button" onclick="asignarTerminal(#{terminal.idterminalImpresion});" action="#{terminalesImpresionManBean.asociarTerminal()}">
                                            <i class="level down icon" />
                                            Asociar
                                            <f:ajax execute="form-tabla:idterminal form-tabla:fechahoraasignacion @this" render="form-tabla:tabla-datos" onevent="function(data){ajaxAsignarTerminal(data)}" />
                                        </h:commandLink>
                                    </td>
                                </tr>
                            </ui:repeat>
                        </tbody>
                    </table>
                    <input type="hidden" id="selbar" name="selbar" jsf:value="#{terminalesImpresionManBean.jsonSeleccion}" />
                    <h:commandLink style="display: none" id="cml-enviar-seleccion" actionListener="#{terminalesImpresionManBean.seleccionTerminales()}">
                        <f:ajax execute="selbar" render="form-datos" onevent="function(data){ajaxEnviarSeleccion(data)}" />
                    </h:commandLink>
                </h:form>
            </div>
            <div class="six wide column">
                <div class="ui pointing secondary menu">
                    <a class="item active" id="tab-filtros" data-tab="formulario">Formulario</a>
                </div>
                <div class="ui active tab" data-tab="formulario">
                    <h:form class="ui form" id="form-datos">
                        <div class="field">
                            <label>ID</label>
                            <input type="number" placeholder="ID" disabled="true" jsf:value="#{terminalesImpresionManBean.terminalImpresionVar.idterminalImpresion}" />
                        </div>
                        <div class="field">
                            <label>Descripción</label>
                            <input type="text" placeholder="Descripción" jsf:value="#{terminalesImpresionManBean.terminalImpresionVar.descripcion}" />
                        </div>
                        <h:commandLink id="btn-agregar" class="ui right labeled blue icon button" actionListener="#{terminalesImpresionManBean.registrarTerminal()}">
                            <i class="circle add icon" />
                            Agregar
                            <f:ajax execute="@form" render="@form form-datos:lbl-msg-status form-tabla lbl-msg-status" onevent="function(data){ajaxAgregar(data)}" />
                        </h:commandLink>
                        <h:commandLink id="btn-guardar" style="display: none" class="ui right labeled teal icon button" actionListener="#{terminalesImpresionManBean.guardarTerminal()}">
                            <i class="save icon" />
                            Guardar
                            <f:ajax execute="@form" render="@form form-datos:lbl-msg-status form-tabla lbl-msg-status" onevent="function(data){ajaxModificar(data)}" />
                        </h:commandLink>

                    </h:form>
                    <div id="msg-status" class="ui hidden info message">
                        <i class="close icon"></i>
                        <div id="titulo-msg" class="header">
                            Agregar Terminal de impresión
                        </div>
                        <h:outputText id="lbl-msg-status" value="#{terminalesImpresionManBean.msg}" />
                    </div>
                </div>
            </div>
            <h:form id="dlg-conf-elim" class="ui basic modal">
                <input name="selbar" id="selbar" type="hidden" jsf:value="#{suscripcionManBean.seleccionJson}"/>
                <div class="ui icon header">
                    <i class="trash icon"></i>
                    Eliminar Terminales de impresión
                </div>
                <div class="centered content">
                    <p>¿Desea eliminar los elementos seleccionados?</p>
                </div>
                <div class="actions">
                    <button jsf:action="#{terminalesImpresionManBean.eliminarTerminales()}" class="ui green ok inverted button">
                        <i class="checkmark icon"></i>
                        Sí
                        <f:ajax execute="@form" onevent="function(data){ajaxEliminar(data)}" render="form-tabla form-datos lbl-msg-status"/>
                    </button>
                    <div class="ui red basic cancel inverted button">
                        <i class="remove icon"></i>
                        No
                    </div>
                </div>
            </h:form>
        </div>
        <script type="text/javascript">
            $(document).ready(function () {
                if (typeof (Storage) !== "undefined") {
                    console.log("ID " + localStorage.getItem('idterminal'));
                    console.log("Fecha " + localStorage.getItem('fechahoraasignacionterminal'));
                    actualizarCheckmark();

                } else {
                    console.log("No soporte para local storage :(");
                }

                $('#tab-filtros').tab();
                $('.message .close').on('click', function () {
                    $(this).closest('.message').transition('fade');
                });
            });

            function ajaxAsignarTerminal(data) {
                var s = data.status;
                console.log(s);
                switch (s) {
                    case 'success':
                    {
                        localStorage.setItem("idterminal", $('#form-tabla\\:idterminal').val());
                        localStorage.setItem("fechahoraasignacionterminal", $('#form-tabla\\:fechahoraasignacion').val());
                        actualizarCheckmark();
                        break;
                    }
                }
            }

            function actualizarCheckmark() {
                var idt = localStorage.getItem('idterminal');
                $("[id^='ico-este-eq-']").each(function (index, value) {
                    $(this).removeClass('green');
                    $(this).removeClass('checkmark');
                    $(this).addClass('minus');

                });
                $('#ico-este-eq-' + idt).removeClass('minus');
                $('#ico-este-eq-' + idt).addClass('green');
                $('#ico-este-eq-' + idt).addClass('checkmark');
            }

            function asignarTerminal(idterminal) {
                $('#form-tabla\\:idterminal').val(idterminal);
                $('#form-tabla\\:fechahoraasignacion').val(new Date().getTime());
            }

            function ajaxAgregar(data) {
                var s = data.status;
                switch (s) {
                    case 'begin':
                    {
                        $('#form-datos\\:btn-agregar').addClass('loading');
                        $('#form-datos\\:btn-agregar').addClass('disabled');
                        break;
                    }
                    case 'success':
                    {
                        $('#form-datos\\:btn-agregar').removeClass('loading');
                        $('#form-datos\\:btn-agregar').removeClass('disabled');
                        if ($('#msg-status').css('display') === 'none') {
                            $('#msg-status').transition('fade');
                        }
                        break;
                    }
                }
            }
            function ajaxModificar(data) {
                var s = data.status;
                switch (s) {
                    case 'begin':
                    {
                        $('#form-datos\\:btn-guardar').addClass('loading');
                        $('#form-datos\\:btn-guardar').addClass('disabled');
                        break;
                    }
                    case 'success':
                    {
                        $('#form-datos\\:btn-guardar').removeClass('loading');
                        $('#form-datos\\:btn-guardar').removeClass('disabled');
                        if ($('#msg-status').css('display') === 'none') {
                            $('#msg-status').transition('fade');
                        }
                        break;
                    }
                }
            }

            function selecFila(id) {
                var nombFila = "#rw-" + id;
                var nombCheck = "#chk-sl-" + id;
                if ($(nombFila).hasClass('active')) {
                    $(nombFila).removeClass('active');
                    $(nombCheck).prop('checked', false);
                } else {
                    $(nombFila).addClass('active');
                    $(nombCheck).prop('checked', true);
                }
                generarDatosSeleccion();
                modoModificar();
            }

            function selecUnica(id) {
                var nombreFila = "#rw-" + id;
                var nombreChk = "#chk-sl-" + id;
                if ($(nombreFila).hasClass('active')) {
                    $('tbody :checkbox:checked').prop('checked', false);
                    $('#form-tabla\\:tabla-datos tbody tr').removeClass('active');
                    $('#form-barra\\:btn-limpiar').click();
//                    limpiarFormulario();
                } else {
                    $('tbody :checkbox:checked').prop('checked', false);
                    $('#form-tabla\\:tabla-datos tbody tr').removeClass('active');
                    $(nombreFila).addClass('active');
                    $(nombreChk).prop('checked', true);
//                    cargarFormulario(id);
                }
//                ocultarBtnElim();
                modoModificar();
                generarDatosSeleccion();
            }

            function generarDatosSeleccion() {
                var idSeleccionados = [];
                $("tbody tr [id^='col-id-term']").each(function (index, value) {
                    var id = parseInt($(this).html());
                    if ($('#chk-sl-' + id).prop('checked')) {
                        idSeleccionados.push(id);
                    }
                });
                var jsonselect = JSON.stringify(idSeleccionados);
                $('#selbar').val(jsonselect);
                $('#form-tabla\\:cml-enviar-seleccion').click();
//                $('#div-btn-elim').hide();
            }
            function modoModificar() {
                var seleccionados = $('tbody :checkbox:checked').length;
                if (seleccionados === 1) {
//                    mostrarCamposPrimeraCuota(true);
                    $('#form-datos\\:btn-guardar').css('display', 'inline-block');
                    $('#form-datos\\:btn-agregar').css('display', 'none');
                    $('#btn-elim').show();
                } else {

//                    mostrarCamposPrimeraCuota(false);
//                    $('#form-datos\\:btn-guardar').css('display', 'none');
                    $('#form-datos\\:btn-guardar').hide();
                    $('#form-datos\\:btn-agregar').css('display', 'inline-block');                    

                }
                if (seleccionados >= 1) {
                    $('#btn-elim').show();
                } else {
                    $('#btn-elim').hide();
                }

            }

            $('#btn-elim').click(function () {
                $('#dlg-conf-elim').modal('show');
            });

            function ajaxEliminar(data) {
                var s = data.status;
                switch (s) {
                    case 'success':
                    {
                        if ($('#msg-status').css('display') === 'none') {
                            $('#msg-status').transition('fade');
                        }
                        break;
                    }
                }
            }
            function ajaxEnviarSeleccion(data) {
                var s = data.status;
                switch (s) {
                    case 'success':
                    {
                        modoModificar();
                        break;
                    }
                }
            }
        </script>
    </ui:define>

</ui:composition>
